/*
This demo code for leonado
onr   Red LED ON
offr  Red LED OFF
ong   Green LED ON
offg  Green LED OFF
onb   Blue LED ON
offb  Blue LED OFF
*/
#include <SoftwareSerial.h>
SoftwareSerial mySerial(7, 8);
String msg = String("");
int SmsContentFlag = 0;
int LED_R= 2;
int LED_G = 3;
int LED_B=4;
int pon=9;
int poff=6;
int lowp=5;
void setup()
{
  mySerial.begin(9600); // the A6 baud rate   
  Serial.begin(9600);  
  pinMode(poff, OUTPUT);  //POWER OFF PIN    Active High
  pinMode(lowp, OUTPUT);  //SLEEP PIN        Active LOW
  pinMode(pon,OUTPUT);   //POWER ON PIN     Active High
  digitalWrite(lowp, HIGH); 
  digitalWrite(poff, LOW); 
  digitalWrite(pon, LOW); 
  pinMode( LED_R, OUTPUT ); 
  pinMode(LED_G, OUTPUT );
  pinMode(LED_B, OUTPUT );
  digitalWrite(LED_R, HIGH ); 
  digitalWrite(LED_G, HIGH );
  digitalWrite(LED_B, HIGH );  
  poweron();
  GprsTextModeSMS();
}
 
void loop()
{
    char SerialInByte;
    if(Serial.available())
    {
       mySerial.print((unsigned char)Serial.read());
    }  
    else if(mySerial.available())
    {
        char SerialInByte;
        SerialInByte = (unsigned char)mySerial.read();
        if( SerialInByte == 13 )
        {
          ProcessGprsMsg();
         }
         if( SerialInByte == 10 ){
         }
         else {
           // EN: store the current character in the message string buffer
           msg += String(SerialInByte);
         }
     }   
}
 
void poweron()
{
     int i=0;
     boolean result = false;
     digitalWrite(pon, HIGH); 
     delay(3000);       
     digitalWrite(pon, LOW);
 //   mySerial.flush();
 //   mySerial.setTimeout(3000);

     result = mySerial.find("OK");
     if(result)
	 Serial.println( "Please send sms to control your device!" );
    else
	{
               for(i=0;i<10;i++)
              {
                     mySerial.println("AT");delay(500);
                     result = mySerial.find("OK");
                     if(result)
                     {
                       Serial.println( "Please send sms to control your device!" );
                       return;
                     }
	       }
         }
}
void ProcessSms( String sms )
{
  Serial.print( "ProcessSms for [" );
  Serial.print( sms );
  Serial.println( "]" ); 
  if( sms.indexOf("onr") >= 0 ){
    digitalWrite(LED_R, LOW);
    Serial.println( "LED Red ON" );
//    return;
  }
  if( sms.indexOf("ong") >= 0 ){
    digitalWrite( LED_G, LOW);
    Serial.println( "LED Green ON" );
//    return;
  }
    if( sms.indexOf("onb") >= 0 ){
    digitalWrite(LED_B, LOW);
    Serial.println( "LED Blue ON" );
//    return;
  }
    if( sms.indexOf("offr") >= 0 ){
        digitalWrite( LED_R,HIGH);
    Serial.println( "LED Red OFF" );
//    return;
  }
  if( sms.indexOf("offg") >= 0 ){
    digitalWrite(LED_G, HIGH );
    Serial.println( "LED Green OFF" );
//    return;
  }
    if( sms.indexOf("offb") >= 0 ){
    digitalWrite(LED_B, HIGH );
    Serial.println( "LED Blue OFF" );
//    return;
  }
}

// EN: Request Text Mode for SMS messaging

void GprsTextModeSMS(){
  mySerial.println( "AT+CMGF=1" );
}
 
void GprsReadSmsStore( String SmsStorePos ){
  // Serial.print( "GprsReadSmsStore for storePos " );
  // Serial.println( SmsStorePos ); 
  mySerial.print( "AT+CMGR=" );
  mySerial.println( SmsStorePos );
}
 
// EN: Clear the GPRS shield message buffer

void ClearGprsMsg(){
  msg = "";
}
 
// EN: interpret the GPRS shield message and act appropiately

void ProcessGprsMsg() 
{
    Serial.println("");
  //  Serial.print( "GPRS Message: [" );
    Serial.print( msg );
//    Serial.println( "]" );
    if( msg.indexOf( "Call Ready" ) >= 0 )
   {
       Serial.println( "*** GPRS Shield registered on Mobile Network ***" );
       GprsTextModeSMS();
   }
 
  // EN: unsolicited message received when getting a SMS message
  // FR: Message non sollicité quand un SMS arrive
  if( msg.indexOf( "+CIEV" ) >= 0 )
  {
     Serial.println( "*** SMS Received ***" );
  }
 
  // EN: SMS store readed through UART (result of GprsReadSmsStore request)  
  if( msg.indexOf( "+CMT:" ) >= 0 )
  {
    // EN: Next message will contains the BODY of SMS
    SmsContentFlag = 1;
    // EN: Following lines are essentiel to not clear the flag!
    ClearGprsMsg();
    return;
  }
 
  // EN: +CMGR message just before indicate that the following GRPS Shield message 
  //     (this message) will contains the SMS body

  if( SmsContentFlag == 1 )
  {
    Serial.println( "*** SMS MESSAGE CONTENT ***" );
    Serial.println( msg );
    Serial.println( "*** END OF SMS MESSAGE ***" );
    ProcessSms( msg );
  }
 
  ClearGprsMsg();
  // EN: Always clear the flag
  SmsContentFlag = 0; 
}
